  /* Zadatak 8.1.2. (str. 80--81)

     Napisite dio programa koji ucitava prirodni broj n,
     te ispisuje je li on prost ili nije.
  */

  /* Provjera svih mogucih netrivijalnih djelitelja od 2 do n - 1, uz
     prekid petlje cim nadjemo prvi takav djelitelj, ako postoji.
     Varijabla prost je odgovor na pitanje ``je li broj prost''.

     U trecoj varijanti, koristimo for petlju i break za prekid petlje.
     Dobijemo kraci tekst programa. Stvarno izvrsavanje traje isto
     kao i kod while, zbog definicije for petlje preko while.
  */

#include <stdio.h>

int main(void)
{
    int n, d, prost;

    printf(" Upisi broj n: ");
    scanf("%d", &n);

        /* Inicijalizacija odgovora (ignoriramo brojeve <= 0). */
    prost = (n >= 2);

        /* For petlja po potencijalnim djeliteljima od n. */
    for (d = 2; d < n; ++d)
        if (n % d == 0) {
            prost = 0;
            break;
        }

        /* Ispis odgovora na pitanje je li broj prost. */
    if (prost)
        printf(" Broj %d je prost\n", n);
    else
        printf(" Broj %d nije prost\n", n);

    return 0;
}
