#include <stdio.h>

/****************************************************************************/

  /* Bubble sort algoritam (zamjene susjeda).
     Varijanta s 13. predavanja iz Prog1 (bubble_3).
     Skracena vanjska petlja, pamti indeks zadnje zamjene.
  */

/****************************************************************************/

  /* Uzlazno sortiranje zamjenama susjeda.
     Skracena vanjska petlja - pamti
     indeks zadnje zamjene u unutarnjoj. */

void bubble_sort(int x[], int n)
{
    int i = n - 1, j, ind_zamj, temp;

    do {
        ind_zamj = -1;
        for (j = 0; j < i; ++j)
            if (x[j] > x[j + 1]) {
                temp = x[j];
                x[j] = x[j + 1];
                x[j + 1] = temp;
                ind_zamj = j;
            }
        i = ind_zamj;    /* Smanji i za sljedeci prolaz. */
    } while (i > 0);
      
    return;
}

/****************************************************************************/

int main(void)
{
    int i, n;
    int x[] = {42, 12, 55, 94, 18, 44, 67};

    n = 7;
    bubble_sort(x, n);

    printf("\n Sortirano polje x:\n");
    for (i = 0; i < n; ++i) {
        printf(" x[%d] = %d\n", i, x[i]);
    }

    return 0;
}
