#include <stdio.h>

  /* Ucitava dva prirodna broja n i d (d >= 2) i
     nalazi najveci (nenegativni cijeli) eksponent e,
     takav da ``d na e'' (d^e) dijeli n.
     Pretpostavljamo da je ulaz korektno zadan, tj.
     da je n >= 1 i d >= 2 (ne treba provjeravati).
     Unistava n dijeljenjem.
  */

int main(void)
{
    unsigned int n, d, e;

    printf(" Upisi prirodne brojeve n i d >= 2: ");
    scanf("%u %u", &n, &d);
    printf("\n n = %u, d = %u\n", n, d);

        /* Inicijalizacija eksponenta e. */
    e = 0;

        /* Sve dok je n djeljiv s d,
           podijeli ga s d i povecaj e za 1. */
    while (n % d == 0) {
        ++e;
        n /= d;
    }

    printf(" Najveci eksponent od d u n je %u\n", e);

    return 0;
}
