  /* Zadatak 8.1.2. (str. 80--81)

     Napisite dio programa koji ucitava prirodni broj n,
     te ispisuje je li on prost ili nije.
  */

  /* Provjera svih mogucih netrivijalnih djelitelja od 2 do n - 1, uz
     prekid petlje cim nadjemo prvi takav djelitelj, ako postoji.
     Varijabla prost je odgovor na pitanje ``je li broj prost''.

     U drugoj varijanti, koristimo naredbu break za prekid petlje.
  */

#include <stdio.h>

int main(void)
{
    int n, d, prost;

    printf(" Upisi broj n: ");
    scanf("%d", &n);

        /* Inicijalizacija odgovora (ignoriramo brojeve <= 0). */
    prost = (n >= 2);

        /* While petlja po potencijalnim djeliteljima od n. */
    d = 2;
    while (d < n) {
        if (n % d == 0) {
            prost = 0;
            break;
        }
        ++d;
    }

        /* Ispis odgovora na pitanje je li broj prost. */
    if (prost)
        printf(" Broj %d je prost\n", n);
    else
        printf(" Broj %d nije prost\n", n);

    return 0;
}
