#include <stdio.h>
#include <stdlib.h>

  /* Euklidov algoritam za najvecu zajednicku mjeru.
     Koristi samo oduzimanje (nema dijeljenja i ostatka).
     Uvijek vraca M(a, b) > 0.
     Realizacija FUNKCIJOM. */

int euklid (int a, int b)
{
    a = abs(a); b = abs(b);

    while (a != b)
        if (a > b)
            a -= b;
        else
            b -= a;
    return a;    /* Moze i b. */
}

int main(void)
{
    int a, b, mjera;

    printf(" Upisi dva cijela broja a i b: ");
    scanf("%d %d", &a, &b);

    mjera = euklid(a, b);
    printf(" M(%d, %d) = %d\n", a, b, mjera);

    return 0;
}
