
  /* Funkcije za sekvencijalno i binarno trazenje
     zadanog podatka u nizu cijelih brojeva (tipa int).
     Moze se koristiti naredbom #include. */

    /* Sekvencijalno pretrazivanje - funkcija. */

int seq_search(int x[], int n, int elt)
{
    int i;

    for (i = 0; i < n; ++i)
        if (x[i] == elt)
            return 1;

    return 0;
}

    /* Binarno pretrazivanje - funkcija. */

int binary_search(int x[], int n, int elt)
{
    int l = 0, d = n - 1, i;

    while (l <= d) {
        i = (l + d) / 2;
        if (elt < x[i])
            d = i - 1;
        else if (elt > x[i])
            l = i + 1;
        else
            return 1;
    }

    return 0;
}
